<?php
/*
* PAGINA DE CONFIGURACION DE PARAMETROS PARA PAYPALS MANAGER
*/
defined( 'ABSPATH' ) || exit;


{//Menu de de configuracion en admin (para uso posterior)

function my_admin_menu() {
    add_menu_page( 'Paypals', 'Paypals', 'manage_options', 'paypal_config', 'myplguin_admin_page', '', 6  );
}
function myplguin_admin_page(){
    echo 'Welcome to admin page';
}
//add_action( 'admin_menu', 'my_admin_menu');
}


// Agrega un submenú de configuración
// PARAMETROS: 
// add_submenu_page( string $parent_slug, string $page_title, string $menu_title, 
// string $capability, string $menu_slug, callable $callback = '', int|float $position = null ):string|false

function paypal_submenu(){

	add_submenu_page(
		'edit.php?post_type=paypals',
		__( 'Paypals Settings', 'paypals' ),
		__( 'Paypals Settings', 'paypals' ),
		'manage_options',
		'PAYPALsettings',
		'paypal_settings_page'
	);
}
add_action( 'admin_menu', 'paypal_submenu');
	
function paypal_settings_page(){
	?>
	<form action="options.php" method="post">
		<?php 
		settings_fields('_paypal_options'); //Llamamos a la seccion de configuracion definida con register_setting()
		do_settings_sections('paypal_fields'); //Mostramos la sección definida con add_settings_section
		?>
		<input name="submit" class="button button-primary" type="submit" value="<?php esc_attr_e( 'Save' ); ?>" />
		<hr>
  </form>
	<?php
} // function wao_settings_page() END


  //////REGISTRANDO LOS CAMPOS O VARIABLES EN LA BASE DE DATOS [PASO 1]

  function paypal_register_settings() {
	
	// REGISTRAMOS UNA PAGINA DE CONFIGURACION
	//register_setting( string  $option_group , string  $ option_name , array  $args  =  array()  )
    register_setting( '_paypal_options', '_paypal_options', '_paypal_options_validate' );

	// CREAMOS UNA SECCION DENTRO LA PAGINA DE CONFIGURACION
    // add_settings_section( cadena  $id , cadena  $título , $devolución de llamada invocable  , cadena $página , matriz $argumentos  =  matriz()  )  
	// Muestre las secciones de configuración en la función de devolución de llamada de su página de administración con do_settings_sections() .
	// Agregue campos de configuración a su sección con add_settings_field() . 
	add_settings_section( 'paypal1_settings', 'Paypals manager settings', 'paypals_section_text', 'paypal_fields' );

	// INSERTAMOS CADA INPUT, MEDIANTE UNA FUNCION EXTERNA.
	// add_settings_field( string $id, string $title, callable $callback, string $page, string $section = 'default', array $args = array() )
	// Un add_settings_field asociado a una settings_secction por cada campo de configuración.
	// Por cada uno, hay una función separada para insertar un input.
     add_settings_field( 'paypal_setting_main_url', 'URL de la administraci&oacute;n central de paypals', 'paypal_setting_main_url', 'paypal_fields', 'paypal1_settings' );
     add_settings_field( 'paypal_setting_multiple_countries', 'Paypals para multiples sitios', 'paypal_setting_multiple_countries', 'paypal_fields', 'paypal1_settings' );
     add_settings_field( 'paypal_setting_checkout', 'Paypal checkout activo', 'paypal_setting_checkout', 'paypal_fields', 'paypal1_settings' );
     add_settings_field( 'paypal_setting_payments', 'Paypal payments activo', 'paypal_setting_payments', 'paypal_fields', 'paypal1_settings' );
     //add_settings_field( 'paypal_setting_showactivesales', 'Mostras ventas diarias', 'paypal_setting_showactivesales', 'paypal_fields', 'paypal1_settings' );
     //add_settings_field( 'paypal_setting_showdaysales', 'Mostras ventas diarias', 'paypal_setting_showdaysales', 'paypal_fields', 'paypal1_settings' );
     //add_settings_field( 'paypal_setting_showmonthlysales', 'Mostras ventas mensuales', 'paypal_setting_showmonthlysales', 'paypal_fields', 'paypal1_settings' );
     //add_settings_field( 'paypal_setting_showlifetimesales', 'Mostras ventas mensuales', 'paypal_setting_showlifetimesales', 'paypal_fields', 'paypal1_settings' );
     add_settings_field( 'paypal_setting_showsales', 'Que periodo de ventas mostrar?', 'paypal_setting_showsales', 'paypal_fields', 'paypal1_settings' );
	  
  }
  add_action( 'admin_init', 'paypal_register_settings' );

  /////VALIDACION

  function _paypal_options_validate( $input ) {
      $newinput['urlmanuals'] = trim( $input['urlmanuals'] );
      if ( ! preg_match( '/^[a-z0-9]{32}$/i', $newinput['urlmanuals'] ) ) {
          $newinput['urlmanuals'] = '';
      }
      //return $newinput;
      return $input;
  }

  //////////LOS CAMPOS DEL FORMULARIO, LOS QUE SE VEN [PASO 2]
  function paypals_section_text() {
      echo '<p>Configuracion de Parametros para Paypals.</p>';
  }

  function paypal_setting_main_url() { // Combos (COMBO#SKU|ID*ID)
      $options = get_option( '_paypal_options' );
      echo "<input id='paypal_urlmanuals' name='_paypal_options[urlmanuals]' type='text' style='width:400px;'; value='".esc_attr( $options['urlmanuals'] )."' /><i style='margin-left:20px;'>(Incluir <b>https://</b> y un slash al final.)</i> ";
  }

  function paypal_setting_multiple_countries() { // Solo se muestra y valida si es multisite
	if(is_multisite()){
      $options = get_option( '_paypal_options' );
	  $checked = $options['multiple_countries']=="M"?"checked":"";
	  echo '<input type="radio" id="paypal_multiple_countries" name="_paypal_options[multiple_countries]" value="M" '.$checked.'><label for="multiple_countries">Multiple</label>&nbsp;&nbsp;&nbsp;'; 
	  $checked = $options['multiple_countries']=="S"?"checked":"";
	  echo '<input type="radio" id="paypal_multiple_countries" name="_paypal_options[multiple_countries]" value="S" '.$checked.'><label for="multiple_countries">Single</label>'; 
	}else{
	  echo '<input type="hidden" id="paypal_multiple_countries" name="_paypal_options[multiple_countries]" value="S" >'; 
	}
  }

  function paypal_setting_checkout() { // Combos (COMBO#SKU|ID*ID)
      $options = get_option( '_paypal_options' );
	  $checked = $options['checkout']=="S"?"checked":"";
	  echo '<input type="radio" id="paypal_checkout" name="_paypal_options[checkout]" value="S" '.$checked.'><label for="checkout">Si</label>&nbsp;&nbsp;&nbsp;'; 
	  $checked = $options['checkout']=="N"?"checked":"";
	  echo '<input type="radio" id="paypal_checkout" name="_paypal_options[checkout]" value="N" '.$checked.'><label for="checkout">No</label>&nbsp;&nbsp;&nbsp;'; 
	  echo "<span style='color:gray;font-size:11px;font-style: italic;'>Activo muestra en el ABM de paypals</span>";
  }

  function paypal_setting_payments() { // Combos (COMBO#SKU|ID*ID)
      $options = get_option( '_paypal_options' );
	  $checked = $options['payments']=="S"?"checked":"";
	  echo '<input type="radio" id="paypal_payments" name="_paypal_options[payments]" value="S" '.$checked.'><label for="payments">Si</label>&nbsp;&nbsp;&nbsp;'; 
	  $checked = $options['payments']=="N"?"checked":"";
	  echo '<input type="radio" id="paypal_payments" name="_paypal_options[payments]" value="N" '.$checked.'><label for="payments">No</label>&nbsp;&nbsp;&nbsp;'; 
	  echo "<span style='color:gray;font-size:11px;font-style: italic;'>Activo muestra en el ABM de paypals</span>";
  }

  function paypal_setting_showactivesales() { 
      $options = get_option( '_paypal_options' );
	  $checked = $options['activesales']=="S"?"checked":"";
	  echo '<input type="radio" id="paypal_activesales" name="_paypal_options[activesales]" value="S" '.$checked.'><label for="activesales">Si</label>&nbsp;&nbsp;&nbsp;'; 
	  $checked = $options['activesales']=="N"?"checked":"";
	  echo '<input type="radio" id="paypal_activesales" name="_paypal_options[activesales]" value="N" '.$checked.'><label for="activesales">No</label>&nbsp;&nbsp;&nbsp;'; 
	  echo "<span style='color:gray;font-size:11px;font-style: italic;'>Activo muestra este dato en el widget</span>";
  }      

  function paypal_setting_showdaysales() { 
      $options = get_option( '_paypal_options' );
	  $checked = $options['daysales']=="S"?"checked":"";
	  echo '<input type="radio" id="paypal_daysales" name="_paypal_options[daysales]" value="S" '.$checked.'><label for="daysales">Si</label>&nbsp;&nbsp;&nbsp;'; 
	  $checked = $options['daysales']=="N"?"checked":"";
	  echo '<input type="radio" id="paypal_daysales" name="_paypal_options[daysales]" value="N" '.$checked.'><label for="daysales">No</label>&nbsp;&nbsp;&nbsp;'; 
	  echo "<span style='color:gray;font-size:11px;font-style: italic;'>Activo muestra este dato en el widget</span>";
  }      

  function paypal_setting_showmonthlysales() { 
      $options = get_option( '_paypal_options' );
	  $checked = $options['monthlysales']=="S"?"checked":"";
	  echo '<input type="radio" id="paypal_monthlysales" name="_paypal_options[monthlysales]" value="S" '.$checked.'><label for="monthlysales">Si</label>&nbsp;&nbsp;&nbsp;'; 
	  $checked = $options['monthlysales']=="N"?"checked":"";
	  echo '<input type="radio" id="paypal_monthlysales" name="_paypal_options[monthlysales]" value="N" '.$checked.'><label for="monthlysales">No</label>&nbsp;&nbsp;&nbsp;'; 
	  echo "<span style='color:gray;font-size:11px;font-style: italic;'>Activo muestra este dato en el widget</span>";
  }      

  function paypal_setting_showlifetimesales() { 
      $options = get_option( '_paypal_options' );
	  $checked = $options['lifetimesales']=="S"?"checked":"";
	  echo '<input type="radio" id="paypal_lifetimesales" name="_paypal_options[lifetimesales]" value="S" '.$checked.'><label for="lifetimesales">Si</label>&nbsp;&nbsp;&nbsp;'; 
	  $checked = $options['lifetimesales']=="N"?"checked":"";
	  echo '<input type="radio" id="paypal_lifetimesales" name="_paypal_options[lifetimesales]" value="N" '.$checked.'><label for="lifetimesales">No</label>&nbsp;&nbsp;&nbsp;'; 
	  echo "<span style='color:gray;font-size:11px;font-style: italic;'>Activo muestra este dato en el widget</span>";
  }        

  function paypal_setting_showsales() { 
      $options = get_option( '_paypal_options' );
	  $checked = $options['periodsales']=="A"?"checked":"";
	  echo '<input type="radio" id="paypal_periodsales" name="_paypal_options[periodsales]" value="A" '.$checked.'><label for="lifetimesales">Desde activado</label>&nbsp;&nbsp;&nbsp;'; 
	  $checked = $options['periodsales']=="D"?"checked":"";
	  echo '<input type="radio" id="paypal_periodsales" name="_paypal_options[periodsales]" value="D" '.$checked.'><label for="lifetimesales">Diario</label>&nbsp;&nbsp;&nbsp;'; 
	  $checked = $options['periodsales']=="M"?"checked":"";
	  echo '<input type="radio" id="paypal_periodsales" name="_paypal_options[periodsales]" value="M" '.$checked.'><label for="lifetimesales">Mensual</label>&nbsp;&nbsp;&nbsp;'; 
	  $checked = $options['periodsales']=="L"?"checked":"";
	  echo '<input type="radio" id="paypal_periodsales" name="_paypal_options[periodsales]" value="L" '.$checked.'><label for="lifetimesales">Total</label>&nbsp;&nbsp;&nbsp;'; 
	  echo "<span style='color:gray;font-size:11px;font-style: italic;'>Activo muestra este dato en el widget</span>";
  }          